## ccache 3.6

=== debian/changelog ===
ccache (3.6-1) unstable; urgency=medium

  * New upstream release 3.6
  * Update debian/copyright to match ccache's LICENSE.adoc
  * Bump Standards-Version to 4.3.0 with no changes

 -- Joel Rosdahl <joel@debian.org>  Thu, 17 Jan 2019 22:05:24 +0100

=== debian/control ===
Source: ccache
Section: devel
Priority: optional
Maintainer: Joel Rosdahl <joel@debian.org>
Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
Standards-Version: 4.3.0
Homepage: https://ccache.samba.org

Package: ccache
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: distcc | icecc
Description: Compiler cache for fast recompilation of C/C++ code
 ccache is a compiler cache. It speeds up recompilation by caching
 previous compilations and detecting when the same compilation is
 being done again. Supported languages are C, C++, Objective-C and
 Objective-C++.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
        confflags += --build $(DEB_HOST_GNU_TYPE)
else
        confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

config.status: configure-stamp
configure-stamp:
	dh_testdir
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure $(confflags) \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--sysconfdir=/etc
	touch $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: config.status
	dh_testdir
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.guess config.sub
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/ccache.triggers.in >debian/ccache.triggers
	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/update-ccache-symlinks.in >debian/ccache/usr/sbin/update-ccache-symlinks
	$(MAKE) install prefix=$(CURDIR)/debian/ccache/usr
	chmod +x debian/ccache/usr/sbin/update-ccache-symlinks

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	cd debian/ccache/usr/share/doc/ccache && mv NEWS.html changelog.html
	cd debian/ccache/usr/share/doc/ccache && mv MANUAL.html manual.html
	dh_installexamples
	dh_installmenu
	dh_installcron
	dh_installman debian/update-ccache-symlinks.8
	dh_installinfo
	dh_installchangelogs doc/NEWS.adoc
	dh_link
	dh_lintian
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: build build-arch build-indep clean install binary binary-indep binary-arch

## ccache 3.7.2

=== debian/changelog ===
ccache (3.7.2-3) unstable; urgency=medium

  * Source-only upload.

 -- Joel Rosdahl <joel@debian.org>  Sat, 03 Aug 2019 11:25:31 +0200

ccache (3.7.2-2) unstable; urgency=medium

  * Disable cleanup test that fails on compressed/encrypted file systems

 -- Joel Rosdahl <joel@debian.org>  Mon, 22 Jul 2019 22:01:48 +0200

ccache (3.7.2-1) unstable; urgency=medium

  * New upstream release 3.7.2
  * Bump to debhelper 12 and rewrite debian/rules to dh

 -- Joel Rosdahl <joel@debian.org>  Mon, 22 Jul 2019 20:51:39 +0200

ccache (3.7.1-1) unstable; urgency=medium

  * New upstream release 3.7.1
  * Update to new ccache web site
  * Update debian/watch to check ccache's GitHub releases page
  * Update debian/copyright to match ccache's LICENSE.adoc

 -- Joel Rosdahl <joel@debian.org>  Wed, 01 May 2019 22:06:18 +0200

## ccache 3.7.3

=== debian/changelog ===
ccache (3.7.3-1) unstable; urgency=medium

  * New upstream release 3.7.3
  * Remove no longer needed disable_cleanup_size_limit_test.patch

 -- Joel Rosdahl <joel@debian.org>  Sun, 18 Aug 2019 19:08:19 +0200

## ccache 3.7.7

=== debian/changelog ===
ccache (3.7.7-1) unstable; urgency=medium

  * New upstream release 3.7.7

 -- Joel Rosdahl <joel@debian.org>  Mon, 06 Jan 2020 17:12:10 +0100

ccache (3.7.6-1) unstable; urgency=medium

  * New upstream release 3.7.6
  * Fixes an upstream bug related to "file_macro sloppiness" and identical
    source files (closes: #944399)

 -- Joel Rosdahl <joel@debian.org>  Sun, 17 Nov 2019 20:57:28 +0100

ccache (3.7.5-1) unstable; urgency=medium

  * New upstream release 3.7.5

 -- Joel Rosdahl <joel@debian.org>  Wed, 23 Oct 2019 21:27:21 +0200

ccache (3.7.4-1) unstable; urgency=medium

  * New upstream release 3.7.4

 -- Joel Rosdahl <joel@debian.org>  Thu, 12 Sep 2019 21:43:24 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
-Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
-Standards-Version: 4.3.0
-Homepage: https://ccache.samba.org
+Build-Depends: debhelper-compat (= 12), zlib1g-dev, dpkg-dev (>= 1.16.1~)
+Standards-Version: 4.4.0
+Homepage: https://ccache.dev
 
 Package: ccache
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/update-ccache-symlinks.in >debian/ccache/usr/sbin/update-ccache-symlinks


override_dh_installdocs:
	dh_installdocs
	cd debian/ccache/usr/share/doc/ccache && mv NEWS.html changelog.html
	cd debian/ccache/usr/share/doc/ccache && mv MANUAL.html manual.html

override_dh_installchangelogs:
	dh_installchangelogs doc/NEWS.adoc

override_dh_installdeb:
	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/ccache.triggers.in >debian/ccache.triggers
	dh_installdeb

## ccache 3.7.11

=== debian/changelog ===
ccache (3.7.11-1) unstable; urgency=medium

  * New upstream release 3.7.11

 -- Joel Rosdahl <joel@debian.org>  Sun, 26 Jul 2020 17:34:16 +0200

ccache (3.7.10-1) unstable; urgency=medium

  * Add Vcs-Browser and Vcs-Git fields
  * New upstream release 3.7.10
  * Bump Standards-Version to 4.5.0 with no changes

 -- Joel Rosdahl <joel@debian.org>  Wed, 24 Jun 2020 19:39:30 +0200

ccache (3.7.9-1) unstable; urgency=medium

  * Add elfutils to Build-Depends
  * New upstream release 3.7.9
  * Bump Standards-Version to 4.4.1 with no changes

 -- Joel Rosdahl <joel@debian.org>  Sun, 29 Mar 2020 19:23:06 +0200

## ccache 3.7.12

=== debian/changelog ===
ccache (3.7.12-1) unstable; urgency=medium

  * New upstream release 3.7.12
  * Keep symlinks in /usr/lib/ccache that are not dangling
  * Install symlink for nvcc (closes: #971834)

 -- Joel Rosdahl <joel@debian.org>  Fri, 09 Oct 2020 09:21:48 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
-Build-Depends: debhelper-compat (= 12), zlib1g-dev, dpkg-dev (>= 1.16.1~)
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (= 12), zlib1g-dev, dpkg-dev (>= 1.16.1~), elfutils
+Standards-Version: 4.5.0
 Homepage: https://ccache.dev
+Vcs-Browser: https://salsa.debian.org/debian/ccache
+Vcs-Git: https://salsa.debian.org/debian/ccache.git
 
 Package: ccache
 Architecture: any

## ccache 4.1

=== debian/changelog ===
ccache (4.1-1) unstable; urgency=medium

  * New upstream release 4.1
  * Use secure copyright file specification URI
  * Add upstream metadata
  * Update Build-Depends to match ccache 4.x requirements
  * Tweak package description
  * Update patch for Debian-specific installation instructions
  * Build all documentation by default
  * Set forwarded status for patches
  * Upgrade to debhelper compat level 13
  * Properly find documentation at new location
  * Update copyright

 -- Joel Rosdahl <joel@debian.org>  Tue, 24 Nov 2020 21:43:36 +0100

=== debian/control ===
Source: ccache
Section: devel
Priority: optional
Maintainer: Joel Rosdahl <joel@debian.org>
Build-Depends: debhelper-compat (= 13), zlib1g-dev, dpkg-dev (>= 1.16.1~), elfutils, cmake (>= 3.5), libzstd-dev (>= 1.1.2), asciidoc, docbook-xml, docbook-xsl
Standards-Version: 4.5.0
Homepage: https://ccache.dev
Vcs-Browser: https://salsa.debian.org/debian/ccache
Vcs-Git: https://salsa.debian.org/debian/ccache.git

Package: ccache
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: distcc | icecc
Description: Compiler cache for fast recompilation of C/C++ code
 Ccache is a compiler cache. It speeds up recompilation by caching
 previous compilations and detecting when the same compilation is
 being done again.

## ccache 4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.3)

project(ccache LANGUAGES C CXX)
if(MSVC)
  enable_language(ASM_MASM)
else()
  enable_language(ASM)
endif()
set(CMAKE_PROJECT_DESCRIPTION "a fast C/C++ compiler cache")

if(NOT "${CMAKE_CXX_STANDARD}")
  set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED YES)
set(CMAKE_C_EXTENSIONS NO)

# Always export compile_commands.json since it's useful for many tools.
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Minimum compiler requirements (fail gracefully instead of producing cryptic
# C++ error messages)
#

# Clang 3.4 and AppleClang 6.0 fail to compile doctest.
# GCC 4.8.4 is known to work OK but give warnings.
if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.5)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8.4)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0))
  message(
    FATAL_ERROR
    "The compiler you are using is too old, sorry.\n"
    "You need one listed here: https://ccache.dev/platform-compiler-language-support.html")
endif()

# All Clang problems / special handling ccache has are because of version 3.5.
# All GCC problems / special handling ccache has are because of version 4.8.4.
if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.6)
    OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0))
  message(
    WARNING
    "The compiler you are using is rather old.\n"
    "If anything goes wrong you might be better off with one listed here:"
    " https://ccache.dev/platform-compiler-language-support.html")

  # Warnings from old compilers are probably useless anyway.
  option(WARNINGS_AS_ERRORS "Treat compiler warnings as errors" FALSE)
endif()

#
# Settings
#
include(CcacheVersion)

if("${CCACHE_VERSION_ORIGIN}" STREQUAL git OR DEFINED ENV{CI})
  set(CCACHE_DEV_MODE ON)
else()
  set(CCACHE_DEV_MODE OFF)
endif()
message(STATUS "Ccache dev mode: ${CCACHE_DEV_MODE}")

include(UseCcache)
include(UseFastestLinker)
include(StandardSettings)
include(StandardWarnings)
include(CIBuildType)
include(DefaultBuildType)

if(NOT ${CMAKE_VERSION} VERSION_LESS "3.9")
  cmake_policy(SET CMP0069 NEW)
  option(ENABLE_IPO "Enable interprocedural (link time, LTO) optimization" OFF)
  if(ENABLE_IPO)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
  endif()
endif()

#
# Configuration
#
include(GNUInstallDirs)
include(GenerateConfigurationFile)
include(GenerateVersionFile)

if(HAVE_SYS_MMAN_H AND HAVE_PTHREAD_MUTEXATTR_SETPSHARED)
  set(INODE_CACHE_SUPPORTED 1)
endif()

#
# Third party
#
set(ZSTD_FROM_INTERNET_DEFAULT OFF)

# Default to downloading deps for Visual Studio, unless using a package manager.
if(MSVC AND NOT CMAKE_TOOLCHAIN_FILE MATCHES "vcpkg|conan")
  set(ZSTD_FROM_INTERNET_DEFAULT ON)
endif()

option(ZSTD_FROM_INTERNET "Download and use libzstd from the Internet" ${ZSTD_FROM_INTERNET_DEFAULT})
find_package(zstd 1.1.2 REQUIRED)

#
# Special flags
#
# Note: Cppcheck will scan everything after this point. zstd is above so it
# doesn't get scanned.
#
include(CodeAnalysis)
option(ENABLE_TRACING "Enable possibility to use internal ccache tracing" OFF)

if(WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  option(STATIC_LINK "Link statically with system libraries" ON)
endif()

#
# Source code
#
add_subdirectory(src)

#
# ccache executable
#
add_executable(ccache src/main.cpp)
target_link_libraries(ccache PRIVATE standard_settings standard_warnings ccache_lib)

#
# Documentation
#
add_subdirectory(doc)

#
# Installation
#
install(TARGETS ccache DESTINATION ${CMAKE_INSTALL_BINDIR})

#
# Packaging
#
include(CcachePackConfig)

#
# Tests
#
option(ENABLE_TESTING "Enable tests" ON)
if(ENABLE_TESTING)
  enable_testing()
  add_subdirectory(unittest)
  add_subdirectory(test)

  # Note: VERSION_GREATER_EQUAL requires CMake 3.17
  if(NOT ${CMAKE_VERSION} VERSION_LESS "3.17")
    list(APPEND CMAKE_CTEST_ARGUMENTS "--output-on-failure")
  endif()

  # Add "check" target which compiles and runs tests.
  set(
    check_command
    ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure)
  if(CMAKE_CONFIGURATION_TYPES)
    list(APPEND check_command --build-config "$<CONFIGURATION>")
  endif()
  add_custom_target(
    check
    COMMAND ${check_command}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS ccache unittest)
endif()

#
# Special formatting targets
#
find_program(
  CLANG_FORMAT_EXE
  NAMES "clang-format"
  DOC "Path to clang-format executable.")
mark_as_advanced(CLANG_FORMAT_EXE) # Don't show in CMake UIs

if(NOT CLANG_FORMAT_EXE)
  message(STATUS "clang-format not found")
else()
  add_custom_target(
    format
    COMMAND misc/format-files --all
    COMMENT "Formatting code"
    USES_TERMINAL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

  add_custom_target(
    check_format
    COMMAND misc/format-files --all --check
    COMMENT "Checking code formatting"
    USES_TERMINAL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

=== doc/CMakeLists.txt ===
find_program(ASCIIDOC_EXE asciidoc)
mark_as_advanced(ASCIIDOC_EXE) # Don't show in CMake UIs

if(NOT ASCIIDOC_EXE)
  message(NOTICE "Could not find asciidoc; documentation will not be generated")
else()
  #
  # HTML documentation
  #
  function(generate_html adoc_file)
    get_filename_component(base_name "${adoc_file}" NAME_WE)
    set(html_file "${base_name}.html")
    add_custom_command(
      OUTPUT "${html_file}"
      COMMAND
        ${ASCIIDOC_EXE}
          -o "${html_file}"
          -a revnumber="${CCACHE_VERSION}"
          -a toc
          -b xhtml11
          "${CMAKE_SOURCE_DIR}/${adoc_file}"
      MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/${adoc_file}"
    )
    set(html_files "${html_files}" "${html_file}" PARENT_SCOPE)
  endfunction()

  generate_html(LICENSE.adoc)
  generate_html(doc/AUTHORS.adoc)
  generate_html(doc/MANUAL.adoc)
  generate_html(doc/NEWS.adoc)

  add_custom_target(doc-html DEPENDS "${html_files}")
  set(doc_files "${html_files}")

  #
  # Man page
  #
  find_program(A2X_EXE a2x)
  mark_as_advanced(A2X_EXE) # Don't show in CMake UIs
  if(NOT A2X_EXE)
    message(WARNING "Could not find a2x; man page will not be generated")
  else()
    # MANUAL.adoc -> MANUAL.xml -> man page
    add_custom_command(
      OUTPUT MANUAL.xml
      COMMAND
        ${ASCIIDOC_EXE}
          -o -
          -a revnumber=${CCACHE_VERSION}
          -d manpage
          -b docbook "${CMAKE_SOURCE_DIR}/doc/MANUAL.adoc"
        | perl -pe 's!<literal>\(.*?\)</literal>!<emphasis role="strong">\\1</emphasis>!g'
            >MANUAL.xml
      MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/doc/MANUAL.adoc"
    )
    add_custom_command(
      OUTPUT ccache.1
      COMMAND ${A2X_EXE} --doctype manpage --format manpage MANUAL.xml
      MAIN_DEPENDENCY MANUAL.xml
    )
    add_custom_target(doc-man-page DEPENDS ccache.1)
    install(
      FILES "${CMAKE_CURRENT_BINARY_DIR}/ccache.1"
      DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
    )
    set(doc_files "${doc_files}" ccache.1)
  endif()

  add_custom_target(doc ALL DEPENDS "${doc_files}")
endif()

=== src/CMakeLists.txt ===
set(
  source_files
  Args.cpp
  AtomicFile.cpp
  CacheEntryReader.cpp
  CacheEntryWriter.cpp
  CacheFile.cpp
  Compression.cpp
  Compressor.cpp
  Config.cpp
  Context.cpp
  Counters.cpp
  Decompressor.cpp
  Depfile.cpp
  Hash.cpp
  Lockfile.cpp
  Logging.cpp
  Manifest.cpp
  MiniTrace.cpp
  NullCompressor.cpp
  NullDecompressor.cpp
  ProgressBar.cpp
  Result.cpp
  ResultDumper.cpp
  ResultExtractor.cpp
  ResultRetriever.cpp
  SignalHandler.cpp
  Stat.cpp
  Statistics.cpp
  TemporaryFile.cpp
  ThreadPool.cpp
  Util.cpp
  ZstdCompressor.cpp
  ZstdDecompressor.cpp
  argprocessing.cpp
  assertions.cpp
  ccache.cpp
  cleanup.cpp
  compopt.cpp
  compress.cpp
  execute.cpp
  hashutil.cpp
  language.cpp
  version.cpp)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files InodeCache.cpp)
endif()

if(WIN32)
  list(APPEND source_files Win32Util.cpp)
endif()

add_library(ccache_lib STATIC ${source_files})
target_compile_definitions(
  ccache_lib PUBLIC -Dnssv_CONFIG_SELECT_STRING_VIEW=nssv_STRING_VIEW_NONSTD
)

if(WIN32)
  target_link_libraries(ccache_lib PRIVATE ws2_32 "psapi")

  if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if(STATIC_LINK)
      target_link_libraries(ccache_lib PRIVATE -static-libgcc -static-libstdc++ -static winpthread -dynamic)
    else()
      target_link_libraries(ccache_lib PRIVATE winpthread)
    endif()
  elseif(STATIC_LINK AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_link_libraries(ccache_lib PRIVATE -static c++ -dynamic)
  endif()
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(
  ccache_lib
  PRIVATE standard_settings standard_warnings ZSTD::ZSTD
          Threads::Threads third_party_lib)

target_include_directories(ccache_lib PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(third_party)

=== test/CMakeLists.txt ===
function(addtest name)
  add_test(
    NAME "test.${name}"
    COMMAND bash ${CMAKE_SOURCE_DIR}/test/run ${name}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )
  set_tests_properties(
    "test.${name}"
    PROPERTIES
    ENVIRONMENT "CCACHE=${CMAKE_BINARY_DIR}/ccache;EXIT_IF_SKIPPED=true")

  if(${CMAKE_VERSION} VERSION_LESS "3.9")
    # Older CMake versions treat skipped tests as errors. Therefore, resort to
    # parsing output for those cases (exit code is not considered). Skipped
    # tests will appear as "Passed".
    set_tests_properties(
      "test.${name}"
      PROPERTIES
      PASS_REGULAR_EXPRESSION "PASSED|Passed|Skipped"
      FAIL_REGULAR_EXPRESSION "[Ww]arning|[Ff]ail|[Er]rror")
  else()
    set_tests_properties("test.${name}" PROPERTIES SKIP_RETURN_CODE 125)
  endif()

endfunction()

if(${CMAKE_VERSION} VERSION_LESS "3.15")
  set(clean_files_prop_name ADDITIONAL_MAKE_CLEAN_FILES)
else()
  set(clean_files_prop_name ADDITIONAL_CLEAN_FILES)
endif()
set_property(
  DIRECTORY PROPERTY
  ${clean_files_prop_name} "${CMAKE_BINARY_DIR}/testdir")

addtest(base)
addtest(basedir)
addtest(cache_levels)
addtest(cleanup)
addtest(color_diagnostics)
addtest(cpp1)
addtest(debug_prefix_map)
addtest(depend)
addtest(direct)
addtest(direct_gcc)
addtest(fileclone)
addtest(hardlink)
addtest(inode_cache)
addtest(input_charset)
addtest(masquerading)
addtest(modules)
addtest(multi_arch)
addtest(no_compression)
addtest(nocpp2)
addtest(nvcc)
addtest(nvcc_direct)
addtest(nvcc_ldir)
addtest(nvcc_nocpp2)
addtest(pch)
addtest(profiling)
addtest(profiling_clang)
addtest(profiling_gcc)
addtest(profiling_hip_clang)
addtest(readonly)
addtest(readonly_direct)
addtest(sanitize_blacklist)
addtest(serialize_diagnostics)
addtest(source_date_epoch)
addtest(split_dwarf)
addtest(upgrade)

=== unittest/CMakeLists.txt ===
set(
  source_files
  TestUtil.cpp
  main.cpp
  test_Args.cpp
  test_AtomicFile.cpp
  test_Checksum.cpp
  test_Compression.cpp
  test_Config.cpp
  test_Counters.cpp
  test_Depfile.cpp
  test_FormatNonstdStringView.cpp
  test_Hash.cpp
  test_Lockfile.cpp
  test_NullCompression.cpp
  test_Stat.cpp
  test_Statistics.cpp
  test_Util.cpp
  test_ZstdCompression.cpp
  test_argprocessing.cpp
  test_ccache.cpp
  test_compopt.cpp
  test_hashutil.cpp)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files test_InodeCache.cpp)
endif()

if(WIN32)
  list(APPEND source_files test_bsdmkstemp.cpp test_Win32Util.cpp)
endif()

add_executable(unittest ${source_files})

target_link_libraries(
  unittest
  PRIVATE standard_settings standard_warnings ccache_lib third_party_lib)

target_include_directories(unittest PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${ccache_SOURCE_DIR}/src)

add_test(NAME unittest COMMAND unittest)

=== src/third_party/CMakeLists.txt ===
add_library(third_party_lib STATIC base32hex.c format.cpp xxhash.c)
if(NOT MSVC)
  target_sources(third_party_lib PRIVATE getopt_long.c)
else()
  target_sources(third_party_lib PRIVATE win32/getopt.c)
  target_compile_definitions(third_party_lib PUBLIC -DSTATIC_GETOPT)
endif()

if(WIN32)
  target_sources(third_party_lib PRIVATE win32/mktemp.c)
endif ()

if(ENABLE_TRACING)
  target_sources(third_party_lib PRIVATE minitrace.c)
endif()

set(xxhdispatchtest [=[
#include "xxh_x86dispatch.c"

int main()
{
  XXH3_64bits_dispatch("foo", 3);
  return 1;
}
]=])

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c" "${xxhdispatchtest}")

try_compile(USE_XXH_DISPATCH ${CMAKE_CURRENT_BINARY_DIR}
  "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c"
  CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${CMAKE_CURRENT_SOURCE_DIR}"
  COMPILE_DEFINITIONS "-DXXH_STATIC_LINKING_ONLY")

target_compile_definitions(third_party_lib INTERFACE "-DXXH_STATIC_LINKING_ONLY")
if(USE_XXH_DISPATCH)
  target_sources(third_party_lib PRIVATE xxh_x86dispatch.c)
  target_compile_definitions(third_party_lib INTERFACE "-DUSE_XXH_DISPATCH")
endif()

# Treat third party headers as system files (no warning for those headers).
target_include_directories(
  third_party_lib
  PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} SYSTEM)

target_link_libraries(third_party_lib PRIVATE standard_settings)
target_link_libraries(third_party_lib INTERFACE blake3)

# These warnings are enabled by default even without e.g. -Wall, but we don't
# want them in third_party.
if(CMAKE_CXX_COMPILER_ID MATCHES "^GNU|Clang$")
  target_compile_options(
    third_party_lib
    PRIVATE
      $<$<COMPILE_LANGUAGE:C>:-Wno-implicit-function-declaration
      -Wno-int-conversion>)
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  target_compile_options(
    third_party_lib
    PRIVATE $<$<COMPILE_LANGUAGE:C>:-Wno-attributes>)
endif()

# Silence warning from winbase.h due to /Zc:preprocessor.
if(MSVC)
  target_compile_options(
    third_party_lib
    PRIVATE /wd5105)
endif()

# The headers are included from the rest of the project, so turn off warnings as
# required.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_options(third_party_lib INTERFACE -Wno-shadow)
endif()

add_subdirectory(blake3)

=== src/third_party/blake3/CMakeLists.txt ===
add_library(blake3 STATIC blake3.c blake3_dispatch_ccache.c blake3_portable.c)

target_link_libraries(blake3 PRIVATE standard_settings)

if(MSVC)
  # No object file is created if masm is passed the compile options from standard_settings,
  # so don't pass any flags at all to assembler (as no flags are needed anyway).
  string(REPLACE "<FLAGS> " "" CMAKE_ASM_MASM_COMPILE_OBJECT "${CMAKE_ASM_MASM_COMPILE_OBJECT}")
endif()

include(CheckCSourceCompiles)

function(add_source_if_enabled feature msvc_flags others_flags intrinsic)
  if(MSVC)
    set(compile_flags "${msvc_flags}")
  else()
    set(compile_flags "${others_flags}")
  endif()

  # First check if it's possible to use the assembler variant for the feature.
  string(TOUPPER "have_asm_${feature}" have_feature)
  if(NOT DEFINED "${have_feature}" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    if(MSVC)
      set(suffix "_x86-64_windows_msvc.asm")
    elseif(WIN32)
      set(suffix "_x86-64_windows_gnu.S")
    else()
      set(suffix "_x86-64_unix.S")
    endif()

    if(NOT CMAKE_REQUIRED_QUIET)
      message(STATUS "Performing Test ${have_feature}")
    endif()

    set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)

    # Must set CMAKE_ASM_MASM_CREATE_STATIC_LIBRARY explicitly otherwise try_compile
    # fails, see https://discourse.cmake.org/t/building-lib-file-from-asm-cmake-bug/1959
    try_compile(
      ${have_feature}
      ${CMAKE_CURRENT_BINARY_DIR}
      "${CMAKE_CURRENT_SOURCE_DIR}/blake3_${feature}${suffix}"
      CMAKE_FLAGS -DCMAKE_ASM_MASM_CREATE_STATIC_LIBRARY=${CMAKE_C_CREATE_STATIC_LIBRARY}
      COMPILE_DEFINITIONS ${compile_flags})

    unset(CMAKE_TRY_COMPILE_TARGET_TYPE)

    if(NOT CMAKE_REQUIRED_QUIET)
      if (${${have_feature}})
        message(STATUS "Performing Test ${have_feature} - Success")
      else()
        message(STATUS "Performing Test ${have_feature} - Failed")
      endif()
    endif()
  endif()

  # If the assembler variant didn't work, try the c variant.
  if(NOT ${have_feature})
    string(TOUPPER "have_c_${feature}" have_feature)
    set(suffix ".c")

    set(CMAKE_REQUIRED_FLAGS ${compile_flags})
    check_c_source_compiles(
      [=[
        #include <immintrin.h>
        int main() { ${intrinsic}; return 0; }
      ]=]
      ${have_feature})
    unset(CMAKE_REQUIRED_FLAGS)
  endif()

  if(${have_feature})
    target_sources(blake3 PRIVATE blake3_${feature}${suffix})
    if(suffix STREQUAL ".c")
      if(MINGW AND feature STREQUAL "avx512")
        # Workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=65782.
        # Taken from blake3's build.rs.
        set(compile_flags "${compile_flags} -fno-asynchronous-unwind-tables")
      endif()
      set_property(
        SOURCE blake3_${feature}${suffix}
        APPEND PROPERTY COMPILE_FLAGS ${compile_flags})
    elseif(NOT MSVC)
      set_property(
        SOURCE blake3_${feature}${suffix}
        PROPERTY COMPILE_FLAGS ${compile_flags})
    endif()
  else()
    string(TOUPPER "blake3_no_${feature}" no_feature)
    target_compile_definitions(blake3 PRIVATE ${no_feature})
  endif()
endfunction()

# https://software.intel.com/sites/landingpage/IntrinsicsGuide/
add_source_if_enabled(sse2 "" "-msse2"
  "_mm_set1_epi32(42)")
add_source_if_enabled(sse41 "" "-msse4.1"
  "_mm_test_all_ones(_mm_set1_epi32(42))")
add_source_if_enabled(avx2 "/arch:AVX2" "-mavx2"
  "_mm256_abs_epi8(_mm256_set1_epi32(42))")
add_source_if_enabled(avx512 "/arch:AVX512" "-mavx512f -mavx512vl"
  "_mm256_abs_epi64(_mm256_set1_epi32(42))")

# Neon is always available on AArch64
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  # https://developer.arm.com/architectures/instruction-sets/simd-isas/neon/intrinsics
  check_c_source_compiles(
    [=[
      #include <arm_neon.h>
      int main() { vdupq_n_s32(42); return 0; }
    ]=]
    HAVE_NEON)
  if(HAVE_NEON)
    target_sources(blake3 PRIVATE blake3_neon.c)
    target_compile_definitions(blake3 PRIVATE BLAKE3_USE_NEON)
  endif()
endif()

=== debian/changelog ===
ccache (4.2-1) unstable; urgency=medium

  * New upstream release 4.2
  * Bump Standards-Version to 4.5.1 with no changes
  * Remove obsolete build_html_docs.patch

 -- Joel Rosdahl <joel@debian.org>  Sun, 07 Feb 2021 20:50:38 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper-compat (= 13), zlib1g-dev, dpkg-dev (>= 1.16.1~), elfutils, cmake (>= 3.5), libzstd-dev (>= 1.1.2), asciidoc, docbook-xml, docbook-xsl
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://ccache.dev
 Vcs-Browser: https://salsa.debian.org/debian/ccache
 Vcs-Git: https://salsa.debian.org/debian/ccache.git

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,6 @@
 override_dh_install:
 	dh_install
 	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/update-ccache-symlinks.in >debian/ccache/usr/sbin/update-ccache-symlinks
-
 
 override_dh_installdocs:
 	dh_installdocs

## ccache 4.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,9 @@
 message(STATUS "Ccache dev mode: ${CCACHE_DEV_MODE}")
 
 include(UseCcache)
-include(UseFastestLinker)
+if(NOT MSVC)
+  include(UseFastestLinker)
+endif()
 include(StandardSettings)
 include(StandardWarnings)
 include(CIBuildType)

=== debian/changelog ===
ccache (4.2.1-0ubuntu1) impish; urgency=medium

  * New upstream version, fixing build with glibc 2.34.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 10 Aug 2021 13:09:19 +1200

ccache (4.2-1build1) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 15:10:38 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ccache
 Section: devel
 Priority: optional
-Maintainer: Joel Rosdahl <joel@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper-compat (= 13), zlib1g-dev, dpkg-dev (>= 1.16.1~), elfutils, cmake (>= 3.5), libzstd-dev (>= 1.1.2), asciidoc, docbook-xml, docbook-xsl
 Standards-Version: 4.5.1
 Homepage: https://ccache.dev

## ccache 4.5.1

=== src/CMakeLists.txt ===
set(
  source_files
  Args.cpp
  AtomicFile.cpp
  Config.cpp
  Context.cpp
  Depfile.cpp
  Fd.cpp
  Hash.cpp
  Lockfile.cpp
  Logging.cpp
  Manifest.cpp
  ProgressBar.cpp
  Result.cpp
  ResultDumper.cpp
  ResultExtractor.cpp
  ResultRetriever.cpp
  SignalHandler.cpp
  Stat.cpp
  TemporaryFile.cpp
  ThreadPool.cpp
  Util.cpp
  argprocessing.cpp
  assertions.cpp
  ccache.cpp
  compopt.cpp
  execute.cpp
  hashutil.cpp
  language.cpp
  version.cpp
)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files InodeCache.cpp)
endif()

if(MTR_ENABLED)
  list(APPEND source_files MiniTrace.cpp)
endif()

if(WIN32)
  list(APPEND source_files Win32Util.cpp)
endif()

add_library(ccache_framework STATIC ${source_files})
target_compile_definitions(
  ccache_framework PUBLIC -Dnssv_CONFIG_SELECT_STRING_VIEW=nssv_STRING_VIEW_NONSTD
)

if(WIN32)
  target_link_libraries(ccache_framework PRIVATE "psapi")

  if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if(STATIC_LINK)
      target_link_libraries(ccache_framework PRIVATE -static-libgcc -static-libstdc++ -static winpthread -dynamic)
    else()
      target_link_libraries(ccache_framework PRIVATE winpthread)
    endif()
  elseif(STATIC_LINK AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_link_libraries(ccache_framework PRIVATE -static c++ -dynamic)
  endif()
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(
  ccache_framework
  PRIVATE standard_settings standard_warnings ZSTD::ZSTD Threads::Threads third_party
)

target_include_directories(ccache_framework PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

if(REDIS_STORAGE_BACKEND)
  target_compile_definitions(ccache_framework PRIVATE -DHAVE_REDIS_STORAGE_BACKEND)
  target_link_libraries(
    ccache_framework
    PUBLIC standard_settings standard_warnings HIREDIS::HIREDIS third_party
  )
endif()

add_subdirectory(compression)
add_subdirectory(core)
add_subdirectory(storage)
add_subdirectory(third_party)
add_subdirectory(util)

=== unittest/CMakeLists.txt ===
set(
  source_files
  TestUtil.cpp
  main.cpp
  test_Args.cpp
  test_AtomicFile.cpp
  test_Config.cpp
  test_Depfile.cpp
  test_FormatNonstdStringView.cpp
  test_Hash.cpp
  test_Lockfile.cpp
  test_NullCompression.cpp
  test_Stat.cpp
  test_Util.cpp
  test_ZstdCompression.cpp
  test_argprocessing.cpp
  test_ccache.cpp
  test_compopt.cpp
  test_compression_types.cpp
  test_core_Statistics.cpp
  test_core_StatisticsCounters.cpp
  test_core_StatsLog.cpp
  test_hashutil.cpp
  test_storage_primary_StatsFile.cpp
  test_storage_primary_util.cpp
  test_util_TextTable.cpp
  test_util_Tokenizer.cpp
  test_util_XXH3_128.cpp
  test_util_XXH3_64.cpp
  test_util_expected.cpp
  test_util_path.cpp
  test_util_string.cpp
)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files test_InodeCache.cpp)
endif()

if(WIN32)
  list(APPEND source_files test_bsdmkstemp.cpp test_Win32Util.cpp)
endif()

add_executable(unittest ${source_files})

target_link_libraries(
  unittest
  PRIVATE standard_settings standard_warnings ccache_framework third_party)

target_include_directories(unittest PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${ccache_SOURCE_DIR}/src)

add_test(NAME unittest COMMAND unittest)

=== src/compression/CMakeLists.txt ===
set(
  sources
  ${CMAKE_CURRENT_SOURCE_DIR}/Compressor.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Decompressor.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/NullCompressor.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/NullDecompressor.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/ZstdCompressor.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/ZstdDecompressor.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/types.cpp
)

target_sources(ccache_framework PRIVATE ${sources})

=== src/core/CMakeLists.txt ===
set(
  sources
  ${CMAKE_CURRENT_SOURCE_DIR}/CacheEntryHeader.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/CacheEntryReader.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/CacheEntryWriter.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Statistics.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/StatisticsCounters.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/StatsLog.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mainoptions.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/types.cpp
)

target_sources(ccache_framework PRIVATE ${sources})

=== src/third_party/CMakeLists.txt ===
add_library(third_party STATIC base32hex.c format.cpp httplib.cpp url.cpp xxhash.c)
if(NOT MSVC)
  target_sources(third_party PRIVATE getopt_long.c)
else()
  target_sources(third_party PRIVATE win32/getopt.c)
  target_compile_definitions(third_party PUBLIC -DSTATIC_GETOPT)
endif()

if(WIN32)
  target_sources(third_party PRIVATE win32/mktemp.c)
endif ()

if(ENABLE_TRACING)
  target_sources(third_party PRIVATE minitrace.c)
endif()

set(xxhdispatchtest [=[
#include "xxh_x86dispatch.c"

int main()
{
  XXH3_64bits_dispatch("foo", 3);
  return 1;
}
]=])

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c" "${xxhdispatchtest}")

try_compile(USE_XXH_DISPATCH ${CMAKE_CURRENT_BINARY_DIR}
  "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c"
  CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${CMAKE_CURRENT_SOURCE_DIR}"
  COMPILE_DEFINITIONS "-DXXH_STATIC_LINKING_ONLY")

target_compile_definitions(third_party INTERFACE "-DXXH_STATIC_LINKING_ONLY")
if(USE_XXH_DISPATCH)
  target_sources(third_party PRIVATE xxh_x86dispatch.c)
  target_compile_definitions(third_party INTERFACE "-DUSE_XXH_DISPATCH")
endif()

# Treat third party headers as system files (no warning for those headers).
target_include_directories(
  third_party
  PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} SYSTEM
)

target_link_libraries(third_party PRIVATE standard_settings)
target_link_libraries(third_party INTERFACE blake3)

if(WIN32)
  target_link_libraries(third_party PRIVATE ws2_32)
endif()

# Silence warning from winbase.h due to /Zc:preprocessor.
if(MSVC)
  target_compile_options(third_party PRIVATE /wd5105)
endif()

add_subdirectory(blake3)

=== src/util/CMakeLists.txt ===
set(
  sources
  ${CMAKE_CURRENT_SOURCE_DIR}/TextTable.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Tokenizer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/file.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/path.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/string.cpp
)

target_sources(ccache_framework PRIVATE ${sources})

=== src/storage/secondary/CMakeLists.txt ===
set(
  sources
  ${CMAKE_CURRENT_SOURCE_DIR}/FileStorage.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/HttpStorage.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/SecondaryStorage.cpp
)

if(REDIS_STORAGE_BACKEND)
  list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/RedisStorage.cpp)
endif()

target_sources(ccache_framework PRIVATE ${sources})

=== src/third_party/blake3/CMakeLists.txt ===
--- 
+++ 
@@ -17,17 +17,17 @@
     set(compile_flags "${others_flags}")
   endif()
 
+  if(MSVC)
+    set(suffix "_x86-64_windows_msvc.asm")
+  elseif(WIN32)
+    set(suffix "_x86-64_windows_gnu.S")
+  else()
+    set(suffix "_x86-64_unix.S")
+  endif()
+
   # First check if it's possible to use the assembler variant for the feature.
   string(TOUPPER "have_asm_${feature}" have_feature)
   if(NOT DEFINED "${have_feature}" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
-    if(MSVC)
-      set(suffix "_x86-64_windows_msvc.asm")
-    elseif(WIN32)
-      set(suffix "_x86-64_windows_gnu.S")
-    else()
-      set(suffix "_x86-64_unix.S")
-    endif()
-
     if(NOT CMAKE_REQUIRED_QUIET)
       message(STATUS "Performing Test ${have_feature}")
     endif()

=== debian/changelog ===
ccache (4.5.1-1) unstable; urgency=medium

  * New upstream release 4.5.1

 -- Joel Rosdahl <joel@debian.org>  Wed, 17 Nov 2021 20:59:25 +0100

ccache (4.5-1) unstable; urgency=medium

  * Refer to common license file for CC0-1.0
  * New upstream release 4.5

 -- Joel Rosdahl <joel@debian.org>  Sat, 13 Nov 2021 16:05:58 +0100

ccache (4.4.2-1) unstable; urgency=high

  * New upstream release 4.4.2, with an important bug fix of a serious
    regression in ccache 4.4 where ccache could produce false direct cache
    hits in some situations if it decides to disable the direct mode
    temporarily (e.g. due to “too new header” file)
  * Remove now obsolete upstream patch for failing .incbin test

 -- Joel Rosdahl <joel@debian.org>  Wed, 29 Sep 2021 08:39:12 +0200

ccache (4.4-1) unstable; urgency=medium

  [ Gregor Jasny ]
  * Add Salsa CI build pipeline config
  * Add autopkgtest
  * Fix blhc CPPFLAGS warnings
  * Exclude time variation due to test failures

  [ Joel Rosdahl ]
  * New upstream release 4.4
  * Bump Standards-Version to 4.6.0 with no changes
  * Update Build-Depends to match ccache 4.4 requirements
  * Update debian_specific_usage_docs.patch to match new manual
  * Apply upstream patch for failing .incbin test with newer binutils
  * Update debian/copyright to match new release

 -- Joel Rosdahl <joel@debian.org>  Fri, 20 Aug 2021 21:44:19 +0200

=== debian/control ===
Source: ccache
Section: devel
Priority: optional
Maintainer: Joel Rosdahl <joel@debian.org>
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), elfutils, cmake (>= 3.10), libzstd-dev (>= 1.1.2), libhiredis-dev (>= 0.14.1), asciidoctor
Standards-Version: 4.6.0
Homepage: https://ccache.dev
Vcs-Browser: https://salsa.debian.org/debian/ccache
Vcs-Git: https://salsa.debian.org/debian/ccache.git

Package: ccache
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: distcc | icecc
Description: Compiler cache for fast recompilation of C/C++ code
 Ccache is a compiler cache. It speeds up recompilation by caching
 previous compilations and detecting when the same compilation is
 being done again.

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+export ASMFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:

## ccache 4.6

=== debian/changelog ===
ccache (4.6-1) unstable; urgency=medium

  * New upstream release 4.6
  * Update debian/copyright

 -- Joel Rosdahl <joel@debian.org>  Mon, 28 Feb 2022 19:36:53 +0100

## ccache 4.6.1

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/CacheEntryHeader.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/CacheEntryReader.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/CacheEntryWriter.cpp
+  ${CMAKE_CURRENT_SOURCE_DIR}/Manifest.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/Statistics.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/StatisticsCounters.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/StatsLog.cpp

=== debian/changelog ===
ccache (4.6.1-1) unstable; urgency=medium

  * New upstream release 4.6.1 (closes: #1007732)
  * Update debian/copyright

 -- Joel Rosdahl <joel@debian.org>  Sun, 15 May 2022 21:48:25 +0200

## ccache 4.6.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ccache LANGUAGES C CXX ASM ASM_MASM)
if(MSVC)
  enable_language(ASM_MASM)
else()
  enable_language(ASM)
endif()
set(CMAKE_PROJECT_DESCRIPTION "a fast C/C++ compiler cache")

if(MSVC)
  set(CMAKE_CXX_STANDARD 17) # Need support for std::filesystem
else()
  set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED YES)
set(CMAKE_C_EXTENSIONS NO)

# Always export compile_commands.json since it's useful for many tools.
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Minimum compiler requirements (fail gracefully instead of producing cryptic
# C++ error messages)
#

if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.8)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0))
  message(
    FATAL_ERROR
    "The compiler you are using is too old, sorry.\n"
    "You need one listed here: https://ccache.dev/platform-compiler-language-support.html")
endif()

if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4)
    OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6))
  message(
    WARNING
    "The compiler you are using is rather old.\n"
    "If anything goes wrong you might be better off with one listed here:"
    " https://ccache.dev/platform-compiler-language-support.html")

  # Warnings from old compilers are probably useless anyway.
  option(WARNINGS_AS_ERRORS "Treat compiler warnings as errors" FALSE)
endif()

#
# Settings
#
include(CcacheVersion)

if(NOT DEFINED CCACHE_DEV_MODE)
  if("${CCACHE_VERSION_ORIGIN}" STREQUAL git OR DEFINED ENV{CI})
    set(CCACHE_DEV_MODE ON)
  else()
    set(CCACHE_DEV_MODE OFF)
  endif()
endif()
message(STATUS "Ccache dev mode: ${CCACHE_DEV_MODE}")

option(ENABLE_IPO "Enable interprocedural (link time, LTO) optimization" OFF)
if(ENABLE_IPO AND NOT MINGW)
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
endif()

include(UseFastestLinker)
include(StandardSettings)
include(StandardWarnings)
include(CIBuildType)
include(DefaultBuildType)

#
# Configuration
#
include(GNUInstallDirs)
include(GenerateConfigurationFile)
include(GenerateVersionFile)

#
# Third party
#
set(HIREDIS_FROM_INTERNET_DEFAULT OFF)
set(ZSTD_FROM_INTERNET_DEFAULT OFF)

# Default to downloading deps for Visual Studio, unless using a package manager.
if(MSVC AND NOT CMAKE_TOOLCHAIN_FILE MATCHES "vcpkg|conan")
  set(HIREDIS_FROM_INTERNET_DEFAULT ON)
  set(ZSTD_FROM_INTERNET_DEFAULT ON)
endif()

option(ZSTD_FROM_INTERNET "Download and use libzstd from the Internet" ${ZSTD_FROM_INTERNET_DEFAULT})
find_package(zstd 1.1.2 MODULE REQUIRED)

option(REDIS_STORAGE_BACKEND "Enable Redis secondary storage" ON)
if(REDIS_STORAGE_BACKEND)
  option(HIREDIS_FROM_INTERNET "Download and use libhiredis from the Internet" ${HIREDIS_FROM_INTERNET_DEFAULT})
  find_package(hiredis 0.13.3 MODULE REQUIRED)
endif()

#
# Special flags
#
# Note: Cppcheck will scan everything after this point. zstd is above so it
# doesn't get scanned.
#
include(CodeAnalysis)
option(ENABLE_TRACING "Enable possibility to use internal ccache tracing" OFF)

if(WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  option(STATIC_LINK "Link statically with system libraries" ON)
endif()

#
# Source code
#
add_subdirectory(src)

#
# ccache executable
#
add_executable(ccache src/main.cpp)
target_link_libraries(ccache PRIVATE standard_settings standard_warnings ccache_framework)

#
# Documentation
#
option(ENABLE_DOCUMENTATION "Enable documentation" ON)
if(ENABLE_DOCUMENTATION)
  add_subdirectory(doc)
endif()

#
# Installation
#
install(TARGETS ccache DESTINATION ${CMAKE_INSTALL_BINDIR})

#
# Packaging
#
include(CcachePackConfig)

#
# Tests
#
option(ENABLE_TESTING "Enable tests" ON)
if(ENABLE_TESTING)
  enable_testing()
  add_subdirectory(unittest)
  add_subdirectory(test)

  # Note: VERSION_GREATER_EQUAL requires CMake 3.17
  if(NOT ${CMAKE_VERSION} VERSION_LESS "3.17")
    list(APPEND CMAKE_CTEST_ARGUMENTS "--output-on-failure")
  endif()

  # Add "check" target which compiles and runs tests.
  set(
    check_command
    ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure)
  if(CMAKE_CONFIGURATION_TYPES)
    list(APPEND check_command --build-config "$<CONFIGURATION>")
  endif()
  add_custom_target(
    check
    COMMAND ${check_command}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS ccache unittest)
endif()

#
# Special formatting targets
#
add_custom_target(
  format
  COMMAND misc/format-files --all
  COMMENT "Formatting code"
  USES_TERMINAL
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_custom_target(
  check_format
  COMMAND misc/format-files --all --check
  COMMENT "Checking code formatting"
  USES_TERMINAL
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,11 +9,10 @@
   Hash.cpp
   Lockfile.cpp
   Logging.cpp
-  Manifest.cpp
   ProgressBar.cpp
   Result.cpp
-  ResultDumper.cpp
   ResultExtractor.cpp
+  ResultInspector.cpp
   ResultRetriever.cpp
   SignalHandler.cpp
   Stat.cpp

=== debian/changelog ===
ccache (4.6.3-1) unstable; urgency=medium

  * New upstream release 4.6.3

 -- Joel Rosdahl <joel@debian.org>  Mon, 05 Sep 2022 15:05:41 +0200
